#include <libxode.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <dlfcn.h>
#include <dirent.h>
#include <sys/stat.h>


typedef enum { WR_OK, WR_NOK } wresult;
typedef enum {WE_TAG_ID      = 1, 
              WE_QUERY_XMLNS = 2, 
              WE_X_XMLNS     = 4,
              WE_ONCE        = 8,
              WE_CONNECT     = 16,
              WE_DISCONNECT  = 32,
              WE_PRESENCE    = 64,
              WE_MESSAGE     = 128,
              WE_FROM        = 256} wevent;
typedef wresult (*wcallback)(const char *id, wevent evt, xode data, void *arg);

/* wijit externals */
void wijit_status(const char *from, const char *msg, ...);
void wijit_add_to_tree(const char *name);

/* connect dialog magic */
void wijit_show_connect_dialog(void);
void wijit_write(char *src, ...);

/* wijit dispatcher */
wresult wijit_load_plugin(const char *filename);
wresult wijit_register(const char *id, wevent evt, wcallback f, void *f_arg);
wresult wijit_unregister(wresult id);
wresult wijit_supply(wevent evt, xode data);

/* chat */
GladeXML *wijit_chat_new(const char *jid);
void wijit_chat_detach_jid(GladeXML *xml, int id);
int wijit_chat_attach_jid(GladeXML *xml, const char *jid);
GladeXML *wijit_chat_new_interface();
GladeXML *wijit_chat_new_window();

/* prefs */
xode wijit_prefs_get();
void wijit_prefs_save();
