#include <wijit.h>

GladeXML *admin__xml;
extern GladeXML *WIJIT__XML;

void admin_buttons(GtkWidget *w, gpointer data);

wresult admin_callback(const char *id, wevent evt, xode x, void *arg)
{
    xode cur;

    admin_buttons(NULL, "clear");

    if(*xode_get_attrib(x, "type") == 'e')
    {
        char *str[5];
        memset(str, 0, 5 * sizeof(char*));

        str[0] = strdup("Failed to Retrieve List");

        gtk_clist_append(GTK_CLIST(glade_xml_get_widget(admin__xml, "admin_list")), str);

        /* error */
        wijit_status("admin", "failed to retrieve list: %s", xode_get_tagdata(x, "error"));
        free(str[0]);
        xode_free(x);
        return WR_OK;
    }

    for(cur = xode_get_firstchild(xode_get_tag(x, "item")); cur != NULL; cur = xode_get_nextsibling(cur))
    {
        char *str[5];
        if(xode_get_type(cur) != XODE_TYPE_TAG) continue;

        memset(str, 0, 5 * sizeof(char *));

        str[0] = xode_get_attrib(cur, "name");
        str[1] = xode_get_attrib(cur, "jid");
        str[2] = strchr(str[0], ' ');
        if(str[2] != NULL)
        {
            *str[2] = '\0';
            str[2] += 2;
            str[3] = strchr(str[2], ',');
            if(str[3] != NULL)
            {
                *str[3] = '\0';
                str[3] += 2;
                str[4] = strchr(str[3], ',');
                if(str[4] != NULL)
                {
                    *str[4] = '\0';
                    str[4] += 2;
                    str[4][strlen(str[4]) - 1] = '\0';
                }
            }
        }
        else
        {
            str[2] = "offline";
        }

        gtk_clist_append(GTK_CLIST(glade_xml_get_widget(admin__xml, "admin_list")), str);
    }
    return WR_OK;
}

void admin_buttons(GtkWidget *w, gpointer data)
{
    static long id = 0;
    if(strcmp((char*)data, "online") == 0)
    {
        char idstr[10];
        char *str[5];

        memset(str, 0, 5 * sizeof(char*));

        str[0] = strdup("Please Wait...");
        admin_buttons(w, "clear");
        gtk_clist_append(GTK_CLIST(glade_xml_get_widget(admin__xml, "admin_list")), str);
        free(str[0]);

        id++;
        snprintf((char*)&idstr, 10, "admin%d", id);
        wijit_register((char*)&idstr, WE_TAG_ID | WE_ONCE, admin_callback, NULL);
        wijit_write("<iq type='get' to='%s/admin' id='%s'><query xmlns='jabber:iq:browse'/></iq>", gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(WIJIT__XML, "wijit_connect_server"))), (char*)&idstr);
    }
    else if(strcmp((char*)data, "clear") == 0)
    {
        gtk_clist_clear(GTK_CLIST(glade_xml_get_widget(admin__xml, "admin_list")));
    }
}

wresult _cb_connect(const char *id, wevent evt, xode x, void *data)
{
    if(evt & WE_CONNECT)
    { /* enable our menus */
        admin_buttons(NULL, "clear");
        gtk_widget_set_sensitive(glade_xml_get_widget(admin__xml, "admin_online"), TRUE);
        gtk_widget_set_sensitive(glade_xml_get_widget(admin__xml, "admin_clear"), TRUE);
    }
    else if(evt & WE_DISCONNECT)
    {
        admin_buttons(NULL, "clear");
        gtk_widget_set_sensitive(glade_xml_get_widget(admin__xml, "admin_online"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(admin__xml, "admin_clear"), FALSE);
    }

    return WR_OK;
}

void init(GladeXML *xml)
{
    xode_pool p = xode_pool_new();
    GtkWidget *notebook = glade_xml_get_widget(xml, "wijit_notebook");

    admin__xml = glade_xml_new(xode_spool_str(p, PLUGIN_DIR, "/admin.glade", p), "admin_interface");
    xode_pool_free(p);

    glade_xml_signal_connect_data(admin__xml, "on_admin_online_clicked", admin_buttons, (gpointer)"online");
    glade_xml_signal_connect_data(admin__xml, "on_admin_clear_clicked", admin_buttons, (gpointer)"clear");

    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), glade_xml_get_widget(admin__xml, "admin_interface"), gtk_label_new("Admin"));

    wijit_register(NULL, WE_CONNECT | WE_DISCONNECT, _cb_connect, NULL);

    wijit_add_to_tree("Admin Plugin");
    wijit_status("ADMIN","Plugin Loaded");
}
