#include <wijit.h>

GladeXML *presence__xml;
GtkWidget *current__button = NULL;

wresult _cb_connect(const char *id, wevent evt, xode x, void *data)
{
    if(evt & WE_CONNECT)
    { /* enable our menus */
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_online"), TRUE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_away"), TRUE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_xa"), TRUE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_dnd"), TRUE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_custom"), TRUE);
        current__button = glade_xml_get_widget(presence__xml, "presence_offline");
    }
    else if(evt & WE_DISCONNECT)
    {
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_online"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_offline"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_away"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_xa"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_dnd"), FALSE);
        gtk_widget_set_sensitive(glade_xml_get_widget(presence__xml, "presence_custom"), FALSE);
        current__button = glade_xml_get_widget(presence__xml, "presence_offline");
    }

    return WR_OK;
}

void custom_presence_ok(GtkWidget *w, gpointer data)
{
    GladeXML *xml = (GladeXML *)data;
    int type = g_list_index(GTK_MENU_SHELL(GTK_OPTION_MENU(glade_xml_get_widget(xml, "presence_custom_type"))->menu)->children, gtk_menu_get_active(GTK_MENU(GTK_OPTION_MENU(glade_xml_get_widget(xml, "presence_custom_type"))->menu)));
    int show = g_list_index(GTK_MENU_SHELL(GTK_OPTION_MENU(glade_xml_get_widget(xml, "presence_custom_show"))->menu)->children, gtk_menu_get_active(GTK_MENU(GTK_OPTION_MENU(glade_xml_get_widget(xml, "presence_custom_show"))->menu)));
    char *status = gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "presence_custom_status")));
    char *forward = gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget(xml, "presence_custom_forward")));
    int priority = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(glade_xml_get_widget(xml, "presence_custom_priority")));

    /* 0 available
     * 1 unavailabe */
    /* 0 online 
     * 1 away
     * 2 xa
     * 3 dnd
     * 4 chat */

    wijit_write("<presence");
    if(*forward != '\0')
        wijit_write(" to='%s'", forward);
    if(type)
        wijit_write(" type='unavailable'");
    wijit_write("><show>");
    switch(show)
    {
        case 0:
            wijit_write("online");
            break;
        case 1:
            wijit_write("away");
            break;
        case 2:
            wijit_write("xa");
            break;
        case 3:
            wijit_write("dnd");
            break;
        case 4:
            wijit_write("chat");
            break;
    };
    wijit_write("</show><status>%s</status><priority>%d</priority></presence>", status, priority);
    gtk_widget_hide(glade_xml_get_widget(xml, "presence_custom_dialog"));
}

void presence_menu_responce(GtkWidget *w, gpointer data)
{
    char *action = (char*)data;
    GtkWidget *new_button;

    if(strcmp(action, "online") == 0)
    {
        new_button = glade_xml_get_widget(presence__xml, "presence_online");
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = new_button;
        gtk_widget_set_sensitive(current__button, FALSE);

        wijit_write("<presence/>");
        wijit_status("presence", "Set to Online");
        return;
    }

    if(strcmp(action, "offline") == 0)
    {
        new_button = glade_xml_get_widget(presence__xml, "presence_offline");
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = new_button;
        gtk_widget_set_sensitive(current__button, FALSE);

        wijit_write("<presence type='unavailable'/>");
        wijit_status("presence", "Set to Offline");
        return;
    }

    if(strcmp(action, "away") == 0)
    {
        new_button = glade_xml_get_widget(presence__xml, "presence_away");
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = new_button;
        gtk_widget_set_sensitive(current__button, FALSE);

        wijit_write("<presence><show>away</show></presence>");
        wijit_status("presence", "Set to Away");
        return;
    }

    if(strcmp(action, "xa") == 0)
    {
        new_button = glade_xml_get_widget(presence__xml, "presence_xa");
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = new_button;
        gtk_widget_set_sensitive(current__button, FALSE);

        wijit_write("<presence><show>xa</show></presence>");
        wijit_status("presence", "Set to Extended Away");
        return;
    }
    if(strcmp(action, "dnd") == 0)
    {
        new_button = glade_xml_get_widget(presence__xml, "presence_dnd");
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = new_button;
        gtk_widget_set_sensitive(current__button, FALSE);

        wijit_write("<presence><show>xa</show></presence>");
        wijit_status("presence", "Set to Extended Away");
        return;
    }

    if(strcmp(action, "custom") == 0)
    {
        GladeXML *xml;
        GtkWidget *dialog;
        xode_pool p = xode_pool_new(); 
        if(current__button != NULL)
            gtk_widget_set_sensitive(current__button, TRUE);
        current__button = NULL;

        xml = glade_xml_new(xode_spool_str(p, PLUGIN_DIR, "/presence.glade", p), "presence_custom_dialog");
        xode_pool_free(p);
        glade_xml_signal_connect_data(xml, "on_presence_custom_ok", custom_presence_ok, (gpointer)xml);
        dialog = glade_xml_get_widget(xml, "presence_custom_dialog");
        glade_xml_signal_connect_data(xml, "on_presence_custom_cancel", gtk_widget_hide, (gpointer)dialog);
        gtk_widget_show(dialog);
        return;
    }
}

void init(GladeXML *xml)
{
    xode_pool p = xode_pool_new();
    GtkWidget *menubar = glade_xml_get_widget(xml, "wijit_main_menubar");
    GtkWidget *presence_item;

    presence__xml = glade_xml_new(xode_spool_str(p, PLUGIN_DIR, "/presence.glade", p), "presence_menu");
    xode_pool_free(p);
    presence_item = glade_xml_get_widget(presence__xml, "presence_menu");

    glade_xml_signal_connect_data(presence__xml, "on_presence_online_activate", presence_menu_responce, (gpointer)"online");
    glade_xml_signal_connect_data(presence__xml, "on_presence_offline_activate", presence_menu_responce, (gpointer)"offline");
    glade_xml_signal_connect_data(presence__xml, "on_presence_away_activate", presence_menu_responce, (gpointer)"away");
    glade_xml_signal_connect_data(presence__xml, "on_presence_xa_activate", presence_menu_responce, (gpointer)"xa");
    glade_xml_signal_connect_data(presence__xml, "on_presence_dnd_activate", presence_menu_responce, (gpointer)"dnd");
    glade_xml_signal_connect_data(presence__xml, "on_presence_custom_activate", presence_menu_responce, (gpointer)"custom");


    gtk_widget_show(presence_item);

    gtk_menu_bar_append(GTK_MENU_BAR(menubar), presence_item);

    wijit_register(NULL, WE_CONNECT | WE_DISCONNECT, _cb_connect, NULL);

    wijit_add_to_tree("Presence Plugin");
    wijit_status("PRESENCE","Plugin Loaded");
}
