#include <wijit.h>

extern GladeXML *WIJIT__XML;
int WIJIT_FD = 0;
gint WIJIT_FD_TAG = 0;
xode_pool WIJIT_XS_POOL = NULL;

void wijit_write(char *src, ...)
{
    va_list va;
    char txt[10000];
    int len;

    if(WIJIT_FD == 0)
        return;
    va_start(va, src);
    vsnprintf((char*)&txt, 10000, src, va);
    va_end(va);

    len = strlen((char*)&txt);
    write(WIJIT_FD, (char*)&txt, len);
    write(WIJIT_FD, "\n", 1);
}

void __io_callback(gpointer data, gint source, GdkInputCondition condition) 
{
    char *buf[1000];
    int len;
    xode_stream xs = (xode_stream)data;

    while((len = read(source, buf, 1000)) <= 1000)
    {
        if(len <= 0)
        {
            gtk_widget_activate(glade_xml_get_widget(WIJIT__XML, "wijit_main_menu_wijit_disconnect"));
            return;
        }

        xode_stream_eat(xs, (char*)&buf, len);
        if(len < 1000)
            break;
    }
}

void _xode_stream_callback(int type, xode x, void *arg)
{
    if(type == XODE_STREAM_CLOSE || type == XODE_STREAM_ERROR)
    {
        gtk_widget_activate(glade_xml_get_widget(WIJIT__XML, "wijit_main_menu_wijit_disconnect"));
        if(x != NULL)
        {
            wijit_status("IO", "ERROR: %s", xode_get_data(x));
            xode_free(x);
        }
        return;
    }

    if(type == XODE_STREAM_ROOT)
    { /* got root.. auth */
        xode_free(x);
        return;
    }

    if(xode_get_attrib(x, "id") != NULL && strcmp(xode_get_attrib(x, "id"), "wijit_auth") == 0)
    {
        GtkWidget *menu_disconnect = glade_xml_get_widget(WIJIT__XML, "wijit_main_menu_wijit_disconnect");
        if(strcmp(xode_get_attrib(x, "type"), "result") != 0)
        {
            /* bad login */
            wijit_status("AUTH", "Failed to authenticate: %s", xode_get_tagdata(x, "error"));

            gtk_widget_activate(glade_xml_get_widget(WIJIT__XML, "wijit_main_menu_wijit_disconnect"));
            return;
        }

        gtk_widget_set_sensitive(menu_disconnect, TRUE);
        wijit_status("AUTH", "Authenticated");
        wijit_supply(WE_CONNECT, NULL);
        xode_free(x);
        return;
    }

    wijit_status("RECV", xode_to_str(x));
    if(wijit_supply(0, x) == WR_NOK && *xode_get_name(x) == 'm')
    {
        if(xode_get_attrib(x, "type") == NULL || *xode_get_attrib(x, "type") == 'c' || *xode_get_attrib(x, "type") == 'n') /* include type='normal', even though it's invalid */
        {
            GladeXML *xml = wijit_chat_new(xode_get_attrib(x, "from"));
            GtkWidget *text = glade_xml_get_widget(xml, "wijit_chat_text");
            gtk_text_set_point(GTK_TEXT(text), gtk_text_get_length(GTK_TEXT(text)));
            gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, "<", 1);
            gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, xode_get_attrib(x, "from"), strlen(xode_get_attrib(x, "from")));
            gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, "> ", 2);
            gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, xode_get_tagdata(x, "body"), xode_get_tagdata(x, "body") ? strlen(xode_get_tagdata(x, "body")) : 0);
            gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, "\n", 1);
        }
    }
    xode_free(x);
}

void on_wijit_connect_cancel_clicked(GtkWidget *w, gpointer data)
{
    GtkWidget *dialog = glade_xml_get_widget(WIJIT__XML, "wijit_connect_dialog");  

    gtk_widget_hide(dialog);
}

void on_wijit_connect_connect_clicked(GtkWidget *w, gpointer data)
{
    GtkWidget *menu_connect = glade_xml_get_widget(WIJIT__XML, "wijit_main_menu_wijit_connect");
    GtkWidget *dialog = glade_xml_get_widget(WIJIT__XML, "wijit_connect_dialog");  
    GtkWidget *gusername = glade_xml_get_widget(WIJIT__XML, "wijit_connect_username");
    GtkWidget *gpassword = glade_xml_get_widget(WIJIT__XML, "wijit_connect_password");
    GtkWidget *gresource = glade_xml_get_widget(WIJIT__XML, "wijit_connect_resource");
    GtkWidget *gserver = glade_xml_get_widget(WIJIT__XML, "wijit_connect_server");
    char *username = (char*)gtk_entry_get_text(GTK_ENTRY(gusername));
    char *password = (char*)gtk_entry_get_text(GTK_ENTRY(gpassword));
    char *resource = (char*)gtk_entry_get_text(GTK_ENTRY(gresource));
    char *server = (char*)gtk_entry_get_text(GTK_ENTRY(gserver));
    int flag=1;
    xode_stream xs;
    /*socket*/
    struct sockaddr_in servaddr;
    struct in_addr **pptr;
    struct hostent *hp;

    if(*username == '\0' || *password == '\0' || *resource == '\0' || *server == '\0')
    {
        wijit_status("IO", "Failed to connect, Must supply all fields.");
        return;
    }

    gtk_widget_hide(dialog);
    gtk_widget_set_sensitive(menu_connect, FALSE);

    wijit_status("IO", "Connecting %s@%s/%s...", username, server, resource);

    hp = gethostbyname(server);

    for(pptr = (struct in_addr **)hp->h_addr_list; *pptr != NULL; pptr++)
    {
        /* perform the connection */
        char buf[100];
        WIJIT_FD = socket(AF_INET, SOCK_STREAM, 0);
        bzero(&servaddr, sizeof(servaddr));
        servaddr.sin_family = AF_INET;
        servaddr.sin_port = htons(5222);
        memcpy(&servaddr.sin_addr, *pptr, sizeof(struct in_addr));
        wijit_status("IO", "Trying %s...", inet_ntop(AF_INET, *pptr, (char*)&buf, 100));

        if(WIJIT_FD < 0 || setsockopt(WIJIT_FD, SOL_SOCKET, SO_REUSEADDR, (char*)&flag, sizeof(flag)) < 0)
        {
            wijit_status("IO", "Failed to Create a Socket");
            gtk_widget_set_sensitive(menu_connect, TRUE);
            return;
        }

        if(connect(WIJIT_FD, (struct sockaddr*)&servaddr, sizeof(servaddr)) == 0)
            break;

        wijit_status("IO", "Failed to Connect.");
        close(WIJIT_FD);
        WIJIT_FD = 0;
    }

    wijit_status("IO", "Connected to %s:5222", server);

    WIJIT_XS_POOL = xode_pool_new();
    xs = xode_stream_new(WIJIT_XS_POOL, _xode_stream_callback, NULL);
    WIJIT_FD_TAG = gdk_input_add(WIJIT_FD, GDK_INPUT_READ, __io_callback, (gpointer)xs);

    wijit_write("<stream:stream to='%s' xmlns='jabber:client' xmlns:stream='http://etherx.jabber.org/streams'>", server);
    wijit_write("<iq type='set' id='wijit_auth'><query xmlns='jabber:iq:auth'><username>%s</username><password>%s</password><resource>%s</resource></query></iq>", username, password, resource);
}

void wijit_show_connect_dialog(void)
{
    GtkWidget *dialog = glade_xml_get_widget(WIJIT__XML, "wijit_connect_dialog");  

    gtk_widget_show(dialog);
}
